摘要:思路這道題主要使用記憶化遞歸和深度優(yōu)先遍歷。我們以給定的矩陣的每一個位置為起點,進行深度優(yōu)先遍歷。我們存儲每個位置深度優(yōu)先遍歷的結果,當下一次走到這個位置的時候,我們直接返回當前位置記錄的值,這樣可以減少遍歷的次數,加快執(zhí)行速度。
Description
Given an integer matrix, find the length of the longest increasing path.
From each cell, you can either move to four directions: left, right, up or down. You may NOT move diagonally or move outside of the boundary (i.e. wrap-around is not allowed).
Example 1:
Input: nums = [ [9,9,4], [6,6,8], [2,1,1] ] Output: 4 Explanation: The longest increasing path is [1, 2, 6, 9].
Example 2:
Input: nums = [ [3,4,5], [3,2,6], [2,2,1] ] Output: 4 Explanation: The longest increasing path is [3, 4, 5, 6]. Moving diagonally is not allowed.描述
給定一個整數矩陣,找出最長遞增路徑的長度。
對于每個單元格,你可以往上,下,左,右四個方向移動。 你不能在對角線方向上移動或移動到邊界外(即不允許環(huán)繞)。
示例 1:
輸入: nums = [ [9,9,4], [6,6,8], [2,1,1] ] 輸出: 4 解釋: 最長遞增路徑為 [1, 2, 6, 9]。
示例 2:
輸入: nums = [ [3,4,5], [3,2,6], [2,2,1] ] 輸出: 4 解釋: 最長遞增路徑是 [3, 4, 5, 6]。注意不允許在對角線方向上移動。思路
這道題主要使用記憶化遞歸和深度優(yōu)先遍歷。
我們以給定的矩陣的每一個位置為起點,進行深度優(yōu)先遍歷。
我們存儲每個位置深度優(yōu)先遍歷的結果,當下一次走到這個位置的時候,我們直接返回當前位置記錄的值,這樣可以減少遍歷的次數,加快執(zhí)行速度。
二維矩陣 dp 初始化每個位置都為 0 ,當遍歷到某個位置不為 0 的時候,說明該位置已經遍歷過了,我們直接返回其值。
# -*- coding: utf-8 -*- # @Author: 何睿 # @Create Date: 2019-03-07 21:19:51 # @Last Modified by: 何睿 # @Last Modified time: 2019-03-07 22:23:10 from itertools import product class Solution: def longestIncreasingPath(self, matrix: [[int]]) -> int: # 如果矩陣為空,返回 0 if not matrix or not matrix[0]: return 0 # 獲取矩陣的行數和列數 row, col = len(matrix), len(matrix[0]) # 記憶化遞歸,記錄每個位置的最大值 dp = [[0] * col for _ in range(row)] # 遍歷每一個位置,以每一個位置為起點進行深度優(yōu)先遍歷 # 返回最大值 return max( self._dfs(i, j, row, col, matrix, dp) for i, j in product(range(row), range(col))) def _dfs(self, i, j, row, col, matrix, dp): # 如果當前位置不為零,說明當前位置的最大值已經被找到 # 采用記憶化遞歸,直接返回最大值 if dp[i][j]: return dp[i][j] # 遍歷四個方向 for x, y in [(0, -1), (-1, 0), (0, 1), (1, 0)]: m, n = x + i, y + j # 如果下一個位置沒有越界并且下一個位置的只嚴格大于位置i,j if 0 <= m < row and 0 <= n < col and matrix[i][j] < matrix[m][n]: # 記錄最大值 dp[i][j] = max(dp[i][j], self._dfs(m, n, row, col, matrix, dp)) # 把當前位置本身加上 dp[i][j] += 1 # 返回以當前位置為起點,所有路徑中的最大值 return dp[i][j]
源代碼文件在 這里 。
?本文首發(fā)于 何睿的博客 ,歡迎轉載,轉載需保留 文章來源 ,作者信息和本聲明.
微信公眾號:techruicore
文章版權歸作者所有,未經允許請勿轉載,若此文章存在違規(guī)行為,您可以聯(lián)系管理員刪除。
轉載請注明本文地址:http://specialneedsforspecialkids.com/yun/43302.html
摘要:題目要求思路和代碼這里采用廣度優(yōu)先算法加上緩存的方式來實現。我們可以看到,以一個節(jié)點作為開始構成的最長路徑長度是確定的。因此我們可以充分利用之前得到的結論來減少重復遍歷的次數。 題目要求 Given an integer matrix, find the length of the longest increasing path. From each cell, you can ei...
摘要:復雜度思路為了避免搜索已經搜索的點。所以考慮用一個數組,記錄到每一個點能產生的最長序列的長度??紤]用進行搜索,對于每一個點來說,考慮先找到最小的那個點針對每一條路徑的。然后對于每一點再遞增回去,依次累積找到增加的值。 LeetCode[329] Longest Increasing Path in a Matrix Given an integer matrix, find the ...
Problem Given an integer matrix, find the length of the longest increasing path. From each cell, you can either move to four directions: left, right, up or down. You may NOT move diagonally or move ou...
Problem Given an integer matrix, find the length of the longest increasing path. From each cell, you can either move to four directions: left, right, up or down. You may NOT move diagonally or move ou...
摘要:題目解答最重要的是用保存每個掃過結點的最大路徑。我開始做的時候,用全局變量記錄的沒有返回值,這樣很容易出錯,因為任何一個用到的環(huán)節(jié)都有可能改變值,所以還是在函數中定義,把當前的直接返回計算不容易出錯。 題目:Given an integer matrix, find the length of the longest increasing path. From each cell, y...
閱讀 3413·2021-11-25 09:43
閱讀 3468·2021-11-19 09:40
閱讀 2470·2021-10-14 09:48
閱讀 1285·2021-09-09 11:39
閱讀 1925·2019-08-30 15:54
閱讀 2826·2019-08-30 15:44
閱讀 2001·2019-08-29 13:12
閱讀 1547·2019-08-29 12:59